# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class IaasapiloadbalancersidoperationsscaleRoutes(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'protocol': 'str',
        'port': 'str',
        'member_protocol': 'str',
        'member_port': 'str',
        'algorithm': 'str',
        'algorithm_parameters': 'str',
        'health_check_configuration': 'IaasapiloadbalancersidoperationsscaleHealthCheckConfiguration'
    }

    attribute_map = {
        'protocol': 'protocol',
        'port': 'port',
        'member_protocol': 'memberProtocol',
        'member_port': 'memberPort',
        'algorithm': 'algorithm',
        'algorithm_parameters': 'algorithmParameters',
        'health_check_configuration': 'healthCheckConfiguration'
    }

    def __init__(self, protocol=None, port=None, member_protocol=None, member_port=None, algorithm=None, algorithm_parameters=None, health_check_configuration=None):  # noqa: E501
        """IaasapiloadbalancersidoperationsscaleRoutes - a model defined in Swagger"""  # noqa: E501
        self._protocol = None
        self._port = None
        self._member_protocol = None
        self._member_port = None
        self._algorithm = None
        self._algorithm_parameters = None
        self._health_check_configuration = None
        self.discriminator = None
        self.protocol = protocol
        self.port = port
        self.member_protocol = member_protocol
        self.member_port = member_port
        if algorithm is not None:
            self.algorithm = algorithm
        if algorithm_parameters is not None:
            self.algorithm_parameters = algorithm_parameters
        if health_check_configuration is not None:
            self.health_check_configuration = health_check_configuration

    @property
    def protocol(self):
        """Gets the protocol of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501

        The protocol of the incoming load balancer requests.  # noqa: E501

        :return: The protocol of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501
        :rtype: str
        """
        return self._protocol

    @protocol.setter
    def protocol(self, protocol):
        """Sets the protocol of this IaasapiloadbalancersidoperationsscaleRoutes.

        The protocol of the incoming load balancer requests.  # noqa: E501

        :param protocol: The protocol of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501
        :type: str
        """
        if protocol is None:
            raise ValueError("Invalid value for `protocol`, must not be `None`")  # noqa: E501

        self._protocol = protocol

    @property
    def port(self):
        """Gets the port of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501

        Port which the load balancer is listening to.  # noqa: E501

        :return: The port of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501
        :rtype: str
        """
        return self._port

    @port.setter
    def port(self, port):
        """Sets the port of this IaasapiloadbalancersidoperationsscaleRoutes.

        Port which the load balancer is listening to.  # noqa: E501

        :param port: The port of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501
        :type: str
        """
        if port is None:
            raise ValueError("Invalid value for `port`, must not be `None`")  # noqa: E501

        self._port = port

    @property
    def member_protocol(self):
        """Gets the member_protocol of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501

        The protocol of the member traffic.  # noqa: E501

        :return: The member_protocol of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501
        :rtype: str
        """
        return self._member_protocol

    @member_protocol.setter
    def member_protocol(self, member_protocol):
        """Sets the member_protocol of this IaasapiloadbalancersidoperationsscaleRoutes.

        The protocol of the member traffic.  # noqa: E501

        :param member_protocol: The member_protocol of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501
        :type: str
        """
        if member_protocol is None:
            raise ValueError("Invalid value for `member_protocol`, must not be `None`")  # noqa: E501

        self._member_protocol = member_protocol

    @property
    def member_port(self):
        """Gets the member_port of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501

        Member port where the traffic is routed to.  # noqa: E501

        :return: The member_port of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501
        :rtype: str
        """
        return self._member_port

    @member_port.setter
    def member_port(self, member_port):
        """Sets the member_port of this IaasapiloadbalancersidoperationsscaleRoutes.

        Member port where the traffic is routed to.  # noqa: E501

        :param member_port: The member_port of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501
        :type: str
        """
        if member_port is None:
            raise ValueError("Invalid value for `member_port`, must not be `None`")  # noqa: E501

        self._member_port = member_port

    @property
    def algorithm(self):
        """Gets the algorithm of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501

        Algorithm employed for load balancing.  # noqa: E501

        :return: The algorithm of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501
        :rtype: str
        """
        return self._algorithm

    @algorithm.setter
    def algorithm(self, algorithm):
        """Sets the algorithm of this IaasapiloadbalancersidoperationsscaleRoutes.

        Algorithm employed for load balancing.  # noqa: E501

        :param algorithm: The algorithm of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501
        :type: str
        """

        self._algorithm = algorithm

    @property
    def algorithm_parameters(self):
        """Gets the algorithm_parameters of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501

        Parameters need for load balancing algorithm.Use newline to separate multiple parameters.  # noqa: E501

        :return: The algorithm_parameters of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501
        :rtype: str
        """
        return self._algorithm_parameters

    @algorithm_parameters.setter
    def algorithm_parameters(self, algorithm_parameters):
        """Sets the algorithm_parameters of this IaasapiloadbalancersidoperationsscaleRoutes.

        Parameters need for load balancing algorithm.Use newline to separate multiple parameters.  # noqa: E501

        :param algorithm_parameters: The algorithm_parameters of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501
        :type: str
        """

        self._algorithm_parameters = algorithm_parameters

    @property
    def health_check_configuration(self):
        """Gets the health_check_configuration of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501


        :return: The health_check_configuration of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501
        :rtype: IaasapiloadbalancersidoperationsscaleHealthCheckConfiguration
        """
        return self._health_check_configuration

    @health_check_configuration.setter
    def health_check_configuration(self, health_check_configuration):
        """Sets the health_check_configuration of this IaasapiloadbalancersidoperationsscaleRoutes.


        :param health_check_configuration: The health_check_configuration of this IaasapiloadbalancersidoperationsscaleRoutes.  # noqa: E501
        :type: IaasapiloadbalancersidoperationsscaleHealthCheckConfiguration
        """

        self._health_check_configuration = health_check_configuration

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(IaasapiloadbalancersidoperationsscaleRoutes, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IaasapiloadbalancersidoperationsscaleRoutes):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
